/***********************************************************************
 *
 *       Filename:   Position.h
 *
 *       Company:    (c) NovAtel Inc.
 *                   1120 68th Avenue N.E.
 *                   Calgary, Alberta.
 *                   Canada. T2E 8S5
 *
 *----------------------------------------------------------------------
 *
 *       COPYRIGHT NovAtel Inc., all rights reserved.
 *
 *       No part of this software may be reproduced or modified in any
 *       form or by any means - electronic, mechanical, photocopying,
 *       recording, or otherwise - without the prior written consent of
 *       NovAtel Inc. and author(s).
 *
 *----------------------------------------------------------------------
 *
 *       Uses NOT Permitted ( You may NOT )
 *          A. Provide use of this software in a computer service 
 *             business with the purpose of making a profit by direct 
 *             use of this software.
 *          B. Grant sublicense, lease, or other rights in this software
 *             to others.
 *
 *       Use Permitted ( You may )
 *          A. Modify and use this software freely in the development 
 *             of your software in order to communicate to the NovAtel 
 *             GPSCard and process the data received either in realtime 
 *             or post-processing mode.
 *
 *       IN NO EVENT WILL NOVATEL BE LIABLE FOR ANY INDIRECT,INCIDENTAL,
 *       SPECIAL OR CONSEQUENTIAL DAMAGES WHETHER THROUGH TORT, CONTRACT
 *       OR OTHERWISE. THIS SOFTWARE IS SUPPLIED ON AN 'AS IS' BASIS.
 *
 **********************************************************************/
#include "header.h"

typedef struct    
{
   unsigned long  sol_stat;           // Solution status
   unsigned long  pos_type;           // Position type
   double         lat;                // Latitude
   double         lon;                // Longitude
   double         hgt;                // Height above mean sea level
   float          und;                // Undulation
   long           datum_id;           // Datum ID
   float          latdev;             // Latitude standard deviation
   float          londev;             // Longitude standard deviation
   float          hgtdev;             // Height standard deviation
   char           ref_station_id[4];  // Reference station ID
   float          lag;                // Differential correction lag
   float          age;                // Solution age
   unsigned char  sats;               // Number of matched satellites
   unsigned char  gps_l1_ranges;      // Number of GPS L1 ranges used
   unsigned char  gps_l1_mask_ranges; // Number of GPS L1 ranges used
   unsigned char  gps_l2_mask_ranges; // Number of GPS L2 ranges used
   char           reserved[4];
} OEM4POSB_LOG;

// BESTPOS log structure
typedef struct
{
   OEM4_BINARY_HEADER      hdr;
   OEM4POSB_LOG            data;
} BESTPOSB_LOG;

// MARKPOS log structure
typedef struct
{
   OEM4_BINARY_HEADER      hdr;
   OEM4POSB_LOG            data;
} MARKPOSB_LOG;

// MATCHEDPOS log structure
typedef struct
{
   OEM4_BINARY_HEADER      hdr;
   OEM4POSB_LOG            data;
} MATCHEDPOSB_LOG;

// PSRPOS log structure
typedef struct
{
   OEM4_BINARY_HEADER      hdr;
   OEM4POSB_LOG            data;
} PSRPOSB_LOG;

// RTKPOS log structure
typedef struct
{
   OEM4_BINARY_HEADER      hdr;
   OEM4POSB_LOG            data;
} RTKPOSB_LOG;
