/*
 * Copyright (C) 2003 LAAS/CNRS 
 *
 * Frederic Camps - Mon Apr 14 2006
 *
 * $Source: 
 * $Revision:
 * $Date: 
 * 
 */

#ifndef __SERIAL_H
#define __SERIAL_H


#include "GPSNovatel.h"


#define TAILLE_BUFFER  7168
#define TAILLE_BUFFER_SERIE 512


/* prototypes */
int openSerial(const char *, int , int , int );

int readSerial(int, int *nbTrame);

int writeSerial(int, char []);

void stockBinaryTrame(unsigned char* ,  int );

int isTrameIsBuffered();

void unStackBuffer(int, int);

void stockArrivalTime(int);

void unStackArrivalTime(int,  int );


void DEBUG_FUNCTION( unsigned char, unsigned short, int, int);


typedef unsigned char uchar;  

/* Structure qui contiendra l'etat de chacun des bit qui compose un char*/
/* cette structure est utilise pour dterminer le type d'une trame binaire */
 typedef struct{
     uchar b0:1;        
     uchar b1:1;
     uchar b2:1;
     uchar b3:1;
     uchar b4:1;
     uchar b5:1;
     uchar b6:1;
     uchar b7:1;        
 }octet;
  
/* union qui me permet de superposer les variable 'valeur' et 'etat'*/
 union _mot{
     char valeur;
     octet etat;
 }mot;
  

// Indique le nombre de trame dans le buffer de sortie
// pour l'utilisateur
int NB_TRAME_BUFFERED;

#endif
