/*!
 * Copyright (c) 2006 Frederic Camps
 *
 * $Source:
 * $Revision: 0.a
 * $Date: 24 april 2006
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#include "horodatage.h"

/*! 
  @brief Procdure qui initialise une structure de donnes de temps

  @param struct timeval *timev : structure de temps  modifier
*/
void getHorodatage(struct timeval *timev)
{
  
  // obsolete en 2038
  if(gettimeofday(timev, NULL) !=0)
    {
      perror("gettimeofday");

      exit(EXIT_FAILURE);
    }
}

/*! 
  @brief Affiche le contenu d'une structure de donnes sous forme ASCII

  @param struct timeval timev : affiche le contenu
*/
struct tm* printHorodatage(struct timeval timev)
{
  struct tm* ptm;
  char time_string[40];
  long milliseconds;

  ptm = localtime (&timev.tv_sec);

  /* Compute milliseconds from microseconds. */
  milliseconds = timev.tv_usec / 1000;
  
  /* Format the date and time, down to a single second. */
  strftime (time_string, sizeof (time_string), "%Y-%m-%d %H:%M:%S", ptm);
  
  /* Print the formatted time, in seconds, followed by a decimal point
     and the milliseconds. */
  printf ("\n************> %s.%03ld <************\n", time_string, milliseconds);
  
  return ptm;
}
