
#include <errno.h>
#include <stdio.h>
#include <string.h>

#include "GPSNovatel.h"
#include "serial.h"
#include "logData.h"

// Descripteur du fichier de log
FILE *fdLog;


/*!



*/
void setLogData(int _verbose, int _verboseLevel, char *_fileName)
{ 
  fdLog = NULL;

  logFile = _fileName;
  modeVerbose= _verbose;
  verboseLevel = _verboseLevel;
  

  // if((fdLog=open(logFile, O_WRONLY| O_CREAT | O_TRUNC, 0644))<0)

  if(modeVerbose==2 && _fileName != NULL)
    {
      if ((fdLog=fopen(logFile, "w+" ))== NULL) 
	{
	  fprintf(stderr, "open log :%s\n", strerror(errno));
	}
    }

  //  close(fdLog);
}


/*!



*/
void logTrame()
{
  int i =0;
	  
 // printf("****> NB TRAME = %d\n", NB_TRAME_BUFFERED);

  // Lecture des informations du GPS et log dans un fichier

  while(i < NB_TRAME_BUFFERED)
    {
      // mode verbeux demand sans log dans fichier, affichage stdout
      if(modeVerbose==1 && fdLog == NULL)
	{	 
	  if( USR_TRAME[i].BINARY_HEADER.number ==  BESTUTMb)
	    {
	      fprintf(stdout,
		      "\nBESTUTMb %i %i %u %u %u %c %.15f %.15f %.15f %.15f %u %.15f"
		      " %.15f %.15f %u %u %u %u %.15f %.15f %u %u %u %u\n",
		       USR_TRAME[i].timev.tv_sec,
		       USR_TRAME[i].timev.tv_usec,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.solStatus,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.posType,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.longitudZoneNumber,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.latitudinalZoneLetter,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.northing,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.easting,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.height,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.undulation,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.datumID,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.northingDev,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.eastingDev,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.heightDev,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[0],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[1],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[2],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[3],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.differentialAge,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.solutionAge,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbSatTracked,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbGPSL1Used,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbGPSL1,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbGPSL2);
	    }

	  if( USR_TRAME[i].BINARY_HEADER.number == BESTPOSb)
	    {
		 
	    }
	}

      // mode verbeux non demand avec log dans fichier
      if(fdLog != NULL && modeVerbose==2)
	{
	  if( USR_TRAME[i].BINARY_HEADER.number ==  BESTUTMb)
	    {
	      fprintf(fdLog,
		      "BESTUTMb %i %i %u %u %u %c %.15f %.15f %.15f %.15f %u %.15f"
		      " %.15f %.15f %u %u %u %u %.15f %.15f %u %u %u %u\n",			
		       USR_TRAME[i].timev.tv_sec,
		       USR_TRAME[i].timev.tv_usec,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.solStatus,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.posType,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.longitudZoneNumber,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.latitudinalZoneLetter,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.northing,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.easting,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.height,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.undulation,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.datumID,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.northingDev,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.eastingDev,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.heightDev,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[0],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[1],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[2],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.baseStationID[3],
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.differentialAge,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.solutionAge,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbSatTracked,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbGPSL1Used,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbGPSL1,
		       USR_TRAME[i].TRAME_TYPE.strOEM4BESTUTMb_LOG.nbGPSL2);
	    }

	  if( USR_TRAME[i].BINARY_HEADER.number ==  BESTXYZb)
	    {
	    }
	}
	  
      i++;

    }// while
  fflush(fdLog);
}

